package jp.gr.java_conf.abagames.brick;

import gl4java.*;

/**
  handle balls
  */
public class BallManager {
  private final int BALL_MAX = 100;
  
  private Ball[] balls = new Ball[BALL_MAX];
  public int ballNmb;
  private GameManager gameManager;
  private boolean slowf;

  public BallManager(
   Racket racket, BlockManager blockManager, GameManager gameManager, 
   boolean slowf, GLFunc gl) {
    for ( int i=0 ; i<BALL_MAX ; i++ ) {
      balls[i] = new Ball(racket, blockManager, this, gameManager, gl);
    }
    this.gameManager = gameManager;
    this.slowf = slowf;
  }

  public void clear() {
    for ( int i=0 ; i<BALL_MAX ; i++ ) {
      balls[i].clear();
    }
  }

  private int cnt = BALL_MAX-1;

  public final void addBall(float x, float y, int deg, float speed, int blCnt) {
    for ( int i=BALL_MAX-1 ; i>=0 ; i-- ) {
      cnt--; if ( cnt < 0 ) cnt = BALL_MAX-1;
      if ( !balls[i].exists() ) {
        balls[i].set(x, y, deg, speed, blCnt);
        ballNmb++;
        return;
      }
    }
  }

  public void roundCleared() {
    float my = -99999;
    int idx = -1;
    for ( int i=BALL_MAX-1 ; i>=0 ; i-- ) {
      if ( balls[i].exists() ) {
        if ( balls[i].y > my ) {
          my = balls[i].y;
          idx = i;
        }
      }
    }
    for ( int i=BALL_MAX-1 ; i>=0 ; i-- ) {
      if ( balls[i].exists() ) {
        if ( i == idx ) {
          balls[i].set(balls[i].x, balls[i].y, 60, 0.3f, 999999999);
        } else {
          if ( balls[i].cnt > 32 || balls[i].cnt < 0 ) balls[i].setCount(32);
        }
      }
    }
  }

  public final boolean move() {
    int nmb = 0;
    for ( int i=BALL_MAX-1 ; i>=0 ; i-- ) {
      if ( balls[i].exists() ) {
        balls[i].move();
        nmb++;
      }
    }
    if ( slowf ) {
      if ( nmb >= BALL_MAX/2 ) {
	gameManager.setDuration(nmb*gameManager.DURATION_DEFAULT*2/BALL_MAX);
      } else {
	gameManager.setDuration(gameManager.DURATION_DEFAULT);
      }
    }
    if ( nmb <= 0 ) return false;
    return true;
  }

  public final void draw() {
    for ( int i=BALL_MAX-1 ; i>=0 ; i-- ) {
      if ( balls[i].exists() ) {
        balls[i].draw();
      }
    }
  }
}

