package jp.gr.java_conf.abagames.brick;

import jp.gr.java_conf.abagames.brick.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;
import gl4java.*;

/**
  racket
  */
public class Racket {
  public static final float YPOS = 2;

  private SceneUI sceneUI;
  private LeftRacketShape leftShape;
  private RightRacketShape rightShape;

  public float x, y, width;
  private float z;

  public Racket(SceneUI sceneUI, GLFunc gl) {
    this.gl = gl;
    this.sceneUI = sceneUI;
    leftShape = new LeftRacketShape();
    rightShape = new RightRacketShape();
    y = -Wall.HEIGHT+YPOS-BallShape.SZ; z = 0;
  }

  public void init() {
    x = -0.2f; width = 0.3f;
    leftShape.setLength(Wall.WIDTH+x-BallShape.SZ);
    rightShape.setLength(Wall.WIDTH-x-width-BallShape.SZ);
  }

  private final float SPEED = 0.2f;

  public final void moveLeft() {
    x -= SPEED;
    move();
  }

  public final void moveRight() {
    x += SPEED;
    move();
  }

  public final void move() {
    if ( sceneUI.lfKey ) {
      x -= SPEED;
    }
    if ( sceneUI.rtKey ) {
      x += SPEED;
    }
    if ( x < -Wall.WIDTH+BallShape.SZ ) {
      x = -Wall.WIDTH+BallShape.SZ;
    }
    if ( x > Wall.WIDTH-width-BallShape.SZ ) {
      x = Wall.WIDTH-width-BallShape.SZ;
    }
    leftShape.setLength(Wall.WIDTH+x-BallShape.SZ);
    rightShape.setLength(Wall.WIDTH-x-width-BallShape.SZ);
  }

  private GLFunc gl;

  public final void draw() {
    gl.glPushMatrix();
    gl.glTranslatef(-Wall.WIDTH, y, z);
    leftShape.draw(gl);
    gl.glPopMatrix();
    gl.glPushMatrix();
    gl.glTranslatef(Wall.WIDTH, y, z);
    rightShape.draw(gl);
    gl.glPopMatrix();
  }
}
