package jp.gr.java_conf.abagames.brick.shapes;

import jp.gr.java_conf.abagames.util.gl4j.*;
import gl4java.*;

public class ConnectedShape implements IShape {
  static private IShape nullShape = new NullShape();

  final private int SHPMAX = 32;

  private IShape[] shapes = new IShape[SHPMAX];
  private int length;
  private float mx;

  public float r, g, b;

  public void set(float mx) {
    this.mx = mx;
    length = 0;
  }

  public void addShape(IShape shape) {
    shapes[length] = shape;
    length++;
  }

  public void skipChar() {
    shapes[length] = nullShape;
    length++;
  }

  public final void draw(GLFunc gl) {
    gl.glColor3f(r, g, b);
    for ( int i=0 ; i<length ; i++ ) {
      shapes[i].draw(gl);
      gl.glTranslatef(mx, 0, 0);
    }
  }
}
