package jp.gr.java_conf.abagames.brick.shapes;

import jp.gr.java_conf.abagames.brick.*;
import jp.gr.java_conf.abagames.util.gl4j.*;
import gl4java.*;

/**
  racket shape - right side
  */
public class RightRacketShape {
  private final float LENGTH = 9.5f, HEIGHT = 2, WIDTH = 0.2f;

  private float[][] vtxs = {
    {-LENGTH, 0, -HEIGHT}, {0, 0, -HEIGHT},
    {-LENGTH, 0, 0}, {0, 0, 0},
    {-LENGTH, -WIDTH, 0}, {0, -WIDTH, 0},
    {-LENGTH, -WIDTH, -HEIGHT}, {0, -WIDTH, -HEIGHT},
    {-LENGTH, 0, 0.05f}, {0, 0, 0.05f},
    {-LENGTH, -WIDTH, 0.05f}, {0, -WIDTH, 0.05f},
  };

  public final void draw(GLFunc gl) {
    gl.glBegin(GLEnum.GL_QUADS);

    if ( ShapeProperties.grdf ) {
    gl.glColor3f(0.2f, 0.2f, 0.2f);
    gl.glVertex3fv(vtxs[0]);
    gl.glVertex3fv(vtxs[1]);
    gl.glColor3f(0.6f, 0.6f, 0.6f);
    gl.glVertex3fv(vtxs[3]);
    gl.glVertex3fv(vtxs[2]);
    } else {
    gl.glColor3f(0.4f, 0.4f, 0.4f);
    gl.glVertex3fv(vtxs[0]);
    gl.glVertex3fv(vtxs[1]);
    gl.glVertex3fv(vtxs[3]);
    gl.glVertex3fv(vtxs[2]);
    }

    gl.glColor3f(1, 1, 1);
    gl.glVertex3fv(vtxs[2]);
    gl.glVertex3fv(vtxs[3]);
    gl.glVertex3fv(vtxs[5]);
    gl.glVertex3fv(vtxs[4]);
    if ( ShapeProperties.grdf ) {
    gl.glColor3f(0.6f, 0.6f, 0.6f);
    gl.glVertex3fv(vtxs[2]);
    gl.glVertex3fv(vtxs[4]);
    gl.glColor3f(0.2f, 0.2f, 0.2f);
    gl.glVertex3fv(vtxs[6]);
    gl.glVertex3fv(vtxs[0]);
    } else {
    gl.glColor3f(0.4f, 0.4f, 0.4f);
    gl.glVertex3fv(vtxs[2]);
    gl.glVertex3fv(vtxs[4]);
    gl.glVertex3fv(vtxs[6]);
    gl.glVertex3fv(vtxs[0]);
    }

    gl.glColor3f(1, 0.7f, 0.4f);
    gl.glVertex3fv(vtxs[8]);
    gl.glVertex3fv(vtxs[9]);
    gl.glVertex3fv(vtxs[11]);
    gl.glVertex3fv(vtxs[10]);
    gl.glEnd();
  }

  public final void setLength(float length) {
    for ( int i=10 ; i>=0 ; i-=2 ) {
      vtxs[i][0] = -length;
    }
    float x = -length+Ball.RKTRFLWDT;
    if ( x > 0 ) x = 0;
    vtxs[9][0] = vtxs[11][0] = x;
  }
}

